package dev.shadowsoffire.apotheosis.adventure.loot;

import com.google.common.base.Preconditions;
import dev.shadowsoffire.placebo.codec.CodecProvider;
import net.minecraft.resources.ResourceLocation;
import com.mojang.serialization.Codec;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;

public class AffixLootRegistry extends WeightedDynamicRegistry<AffixLootEntry>
{
    public static final AffixLootRegistry INSTANCE;
    
    private AffixLootRegistry() {
        super(AdventureModule.LOGGER, "affix_loot_entries", false, false);
    }
    
    protected void registerBuiltinCodecs() {
        this.registerDefaultCodec(Apotheosis.loc("affix_loot_entry"), (Codec)AffixLootEntry.CODEC);
    }
    
    protected void validateItem(final ResourceLocation key, final AffixLootEntry item) {
        super.validateItem(key, (CodecProvider)item);
        Preconditions.checkArgument(!item.stack.m_41619_(), (Object)"Empty itemstacks are not permitted.");
        Preconditions.checkArgument(!item.getType().isNone(), (Object)"Items without a valid loot category are not permitted.");
        Preconditions.checkArgument(item.getMinRarity().ordinal() <= item.getMaxRarity().ordinal(), (Object)"The minimum rarity must be lower or equal to the max rarity.");
    }
    
    static {
        INSTANCE = new AffixLootRegistry();
    }
}
